/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CENTCUSTFIL                                              */
/* Tabela : CENTCUSTFIL                                                       */
/*                                                                            */
/* Criao:                                                                   */
/*                                                                            */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_CENTCUSTFIL'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_CENTCUSTFIL
GO

CREATE TRIGGER DTULTATU_CENTCUSTFIL
ON CENTCUSTFIL
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'CENTCUSTFIL', null, 'CDFILIAL='+ CDFILIAL+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE CENTCUSTFIL
      SET DTULTATU = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(CENTCUSTFIL.CDFILIAL,0) = ISNULL(INSERTED.CDFILIAL,0)) AND
            (ISNULL(CENTCUSTFIL.CDCENTCUST,0) = ISNULL(INSERTED.CDCENTCUST,0));
   END;
END;
GO

UPDATE CENTCUSTFIL SET DTULTATU = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATU IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUCENTCUSTFIL' and
            type = 'D')
   ALTER TABLE CENTCUSTFIL DROP CONSTRAINT DEFAULT_DTULTATUCENTCUSTFIL
GO

ALTER TABLE CENTCUSTFIL ADD CONSTRAINT DEFAULT_DTULTATUCENTCUSTFIL
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATU
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_CENTCUSTFIL','5.09.066';
GO

